# pubspace

[![Build Status](https://drone.autonomic.zone/api/badges/ruangrupa/pubspace/status.svg?ref=refs/heads/main)](https://drone.autonomic.zone/ruangrupa/pubspace)

A service to facilitate collective digital publishing practices.

## Mapping out the pubspace

- **Services**:

  - [cloud.lumbung.space](https://cloud.lumbung.space/) ([Nextcloud](https://nextcloud.com/))
  - [tv.lumbung.space](https://tv.lumbung.space/) ([Peertube](https://joinpeertube.org/))
  - [social.lumbung.space](https://social.lumbung.space/) ([Hometown](https://github.com/hometown-fork/hometown))
  - [lumbung.space](https://lumbung.space/) ([Hugo](https://gohugo.io/))

- **Types of shares**:

  - **cloud.lumbung.space**: links to file paths
  - **tv.lumbung.space**: links to videos
  - **social.lumbung.space**: links to posts

- **Publishing flows**:
  - **cloud.lumbung.space**: Using [Nextcloud flows](https://nextcloud.com/blog/nextcloud-flow-makes-it-easy-to-automate-actions-and-workflows/), we can trigger an outgoing HTTP request towards `pubspace`
  - **tv.lumbung.space**: Using [a federation client](https://mastodonpy.readthedocs.io/) we can watch for specific hashtags to trigger publishing
  - **social.lumbung.space**: Using [a federation client](https://mastodonpy.readthedocs.io/), we can watch for specific hashtags to trigger publishing

## Nextcloud flow script

```bash
echo "TODO"
```

## Deployment

> Work In Progress

```
$ printf $YOURMASTODONACCESSTOKEN | docker secret create  publish_lumbung_space_access_token_v1 -
$ cp .env.sample .env  # and update the values to match the environment
$ set -a && source .env && set +a
$ docker stack deploy -c compose.yml publish_lumbung_space
```
